# Class VulkanPipelineDynamicStateCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineDynamicStateCreateInfo

All Implemented Interfaces:
  `VulkanPipelineDynamicStateCreateInfoType`

public final class VulkanPipelineDynamicStateCreateInfo extends Object implements VulkanPipelineDynamicStateCreateInfoType
Structure specifying parameters of a newly created pipeline dynamic state.

See Also:
  - "VkPipelineDynamicStateCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineDynamicStateCreateInfo.Builder`
  Builds instances of type `VulkanPipelineDynamicStateCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineDynamicStateCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineDynamicStateCreateInfo`.
  `static VulkanPipelineDynamicStateCreateInfo`
  `copyOf(VulkanPipelineDynamicStateCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineDynamicStateCreateInfoType` value.
  `List<VulkanDynamicState>`
  `dynamicStates()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineDynamicStateCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineDynamicStateCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `dynamicStates`.
  `static VulkanPipelineDynamicStateCreateInfo`
  `of(Iterable<VulkanPipelineDynamicStateCreateFlag> flags, Iterable<? extends VulkanDynamicState> dynamicStates)`
  Construct a new immutable `VulkanPipelineDynamicStateCreateInfo` instance.
  `static VulkanPipelineDynamicStateCreateInfo`
  `of(Set<VulkanPipelineDynamicStateCreateFlag> flags, List<VulkanDynamicState> dynamicStates)`
  Construct a new immutable `VulkanPipelineDynamicStateCreateInfo` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineDynamicStateCreateInfo` with attribute values.
  `final VulkanPipelineDynamicStateCreateInfo`
  `withDynamicStates(VulkanDynamicState... elements)`
  Copy the current immutable object with elements that replace the content of `dynamicStates`.
  `final VulkanPipelineDynamicStateCreateInfo`
  `withDynamicStates(Iterable<? extends VulkanDynamicState> elements)`
  Copy the current immutable object with elements that replace the content of `dynamicStates`.
  `final VulkanPipelineDynamicStateCreateInfo`
  `withFlags(VulkanPipelineDynamicStateCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineDynamicStateCreateInfo`
  `withFlags(Iterable<VulkanPipelineDynamicStateCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineDynamicStateCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineDynamicStateCreateInfoType`
    Returns:
      Flags reserved for future use

  - ### dynamicStates

    public List<VulkanDynamicState> dynamicStates()
    Specified by:
      `dynamicStates` in interface `VulkanPipelineDynamicStateCreateInfoType`
    Returns:
      Values specifying which pieces of pipeline state will use the values from dynamic state commands rather than from pipeline state creation info.

  - ### withFlags

    public final VulkanPipelineDynamicStateCreateInfo withFlags(VulkanPipelineDynamicStateCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineDynamicStateCreateInfo withFlags(Iterable<VulkanPipelineDynamicStateCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withDynamicStates

    public final VulkanPipelineDynamicStateCreateInfo withDynamicStates(VulkanDynamicState... elements)
    Copy the current immutable object with elements that replace the content of `dynamicStates`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withDynamicStates

    public final VulkanPipelineDynamicStateCreateInfo withDynamicStates(Iterable<? extends VulkanDynamicState> elements)
    Copy the current immutable object with elements that replace the content of `dynamicStates`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of dynamicStates elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineDynamicStateCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `dynamicStates`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineDynamicStateCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineDynamicStateCreateInfo of(Set<VulkanPipelineDynamicStateCreateFlag> flags, List<VulkanDynamicState> dynamicStates)
    Construct a new immutable `VulkanPipelineDynamicStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `dynamicStates` - The value for the `dynamicStates` attribute
    Returns:
      An immutable VulkanPipelineDynamicStateCreateInfo instance

  - ### of

    public static VulkanPipelineDynamicStateCreateInfo of(Iterable<VulkanPipelineDynamicStateCreateFlag> flags, Iterable<? extends VulkanDynamicState> dynamicStates)
    Construct a new immutable `VulkanPipelineDynamicStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `dynamicStates` - The value for the `dynamicStates` attribute
    Returns:
      An immutable VulkanPipelineDynamicStateCreateInfo instance

  - ### copyOf

    public static VulkanPipelineDynamicStateCreateInfo copyOf(VulkanPipelineDynamicStateCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineDynamicStateCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineDynamicStateCreateInfo instance

  - ### builder

    public static VulkanPipelineDynamicStateCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineDynamicStateCreateInfo`.

         VulkanPipelineDynamicStateCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineDynamicStateCreateFlag) // flags elements
            .addDynamicStates|addAllDynamicStates(com.io7m.jcoronado.api.VulkanDynamicState) // dynamicStates elements
            .build();

    Returns:
      A new VulkanPipelineDynamicStateCreateInfo builder